#!/bin/bash
#
#   Hitachi Fibre Channel HBAAPI Installer for Linux
#
#   Revision 1.2   2005/07/21  add option(version)
#   Revision 1.1   2005/07/05  New release
#
# $1: install   -> install
#     uninstall -> uninstall
#     version   -> version
# $2: Kernel Version  ex. 2.4.21-4EL
#   : NULL -> Kernel Version = `uname -r`
#
INSTDAT=`date`
LIBDIR="/usr/lib"
TOOLSDIR="/opt/hitachi/drivers/hba"
KERNEL2=`uname -r | sed -e 's,[^\.]*\.,,' -e 's,\..*,,'`
KERNEL3=`uname -r | sed -e 's,[^\.]*\.,,' -e 's,[^\.]*\.,,' -e 's,\-.*,,'`
echo "Install Date : $INSTDAT" 
if [ "$1" != "install" -a "$1" != "uninstall" -a "$1" != "version" ]; then
        echo "Usage : hfchbaapiinst.sh install/uninstall" 
        echo "example(install  ) : hfchbaapiinst.sh install"
        echo "       (uninstall) : hfchbaapiinst.sh uninstall"
        echo "       (version  ) : hfchbaapiinst.sh version"
        exit 1
fi
if [ "$1" = "install" ]; then
	echo " -- Install  @Hitachi Fibre Channel HBAAPI Library"
	if [ -f "libhfchbaapi.so" ]; then
		if [ -f "$LIBDIR/libhfchbaapi.so" ]; then
			cp $LIBDIR/libhfchbaapi.so $LIBDIR/libhfchbaapi.so.backup
		
		fi
		if [ $KERNEL2 = "4" ] || [ $KERNEL3 = "9" ]; then
				install -o root -g root libhfchbaapi.so $LIBDIR
				install -o root -g root hfchbaapiinst.sh $TOOLSDIR
		else
				install -o root -g root $TOOLSDIR/libhfchbaapi.so $LIBDIR
		fi
		if [ ! -f "/etc/hba.conf" ]; then
			echo " --- Create /etc/hba.conf " 
    			echo "hfcldd $LIBDIR/libhfchbaapi.so" > /etc/hba.conf
		else
			echo " --- Modify /etc/hba.conf " 
    			COUNT=`grep -c "$LIBDIR/libhfchbaapi" /etc/hba.conf`
    			if [ $COUNT -eq 0 ]; then
				cp /etc/hba.conf /etc/hba.conf.backup
				echo "hfcldd $LIBDIR/libhfchbaapi.so" >> /etc/hba.conf
			fi
    		fi
		strings $LIBDIR/libhfchbaapi.so | grep "libhfchbaapi.so VER" 
		echo " --- Install Success --- " 
	else
    		echo " --- Install Fail (File is not found) --- " 
	fi
elif [ "$1" = "uninstall" ]; then
	echo " -- Uninstall  @Hitachi Fibre Channel HBAAPI Library"
	if [ -f "/etc/hba.conf" ]; then
		echo " --- Modify or remove /etc/hba.conf"
		COUNT=`grep -c "libhfchbaapi" /etc/hba.conf`
		if [ $COUNT -eq 1 ]; then
			cp /etc/hba.conf /etc/hba.conf.temp
			sed "/libhfchbaapi/d" /etc/hba.conf.temp > /etc/hba.conf
			rm /etc/hba.conf.temp
			if [ ! -s /etc/hba.conf ]; then
				rm /etc/hba.conf
			fi
		fi
	fi
	if [ -f "$LIBDIR/libhfchbaapi.so" ]; then
		echo " --- Remove $LIBDIR/libhfchbaapi.so"
		rm -f $LIBDIR/libhfchbaapi.so
	fi
	echo " --- Uninstall Success "
else
	echo " -- Display version of @Hitachi Fibre Channel HBAAPI Library"
	if [ -f "/etc/hba.conf" ]; then
		COUNT=`grep -c "libhfchbaapi" /etc/hba.conf`
		if [ $COUNT -eq 1 ]; then
			if [ -f "$LIBDIR/libhfchbaapi.so" ]; then
				echo " --- Hitachi Fibre Channel HBAAPI Library is installed."
				echo " ======================================================"
				strings $LIBDIR/libhfchbaapi.so | grep "libhfchbaapi.so VER" 
				echo " ======================================================"
			else
			echo " --- Version Display Fail ( No Hitachi HBAAPI Library installed )"
			fi
		else
			echo " --- Version Display Fail ( No Hitachi HBAAPI Library installed )"
		fi
	else
		echo " --- Version Display Fail ( No Hitachi HBAAPI Library installed )"
	fi
fi
